# adaptive-bf.praat
# djmw 20050725


a = 1/2.54
nl$ = "'newline$'"
nl2$ ="'nl$''nl$'"


datadir$ = "/home/david/tex/thesis/data/"
savedir$ = "/home/david/tex/thesis/anorm/"
filename$ = savedir$+"adaptive-bf"
file$ = "'filename$'" + ".txt"
tablefile$ = "'filename$'"+".TableOfReal"

#call test_blocked_vs_mixed
call draw_adaptation_results


procedure prepare_file file$
  filedelete 'file$'
  datum$ = date$()
  fileappend 'file$' 'datum$''nl2$'
  fileappend 'file$' 'tab$'Script: adaptive-formants-procrustes.praat'nl2$'
endproc

procedure test_blocked_vs_mixed
  call prepare_file 'file$'
  call tests
endproc

procedure tests

  call preparedata
  
# Get male and female discriminants

  call extract_dataset fulltable fullindex fulleqclass mlearn
  mlearn = fulltable_sel
  mlearn_eq = fulleqclass_sel
  select mlearn
  To Discriminant
  mdis = selected ("Discriminant")

  call extract_dataset fulltable fullindex fulleqclass wlearn
  wlearn = fulltable_sel
  select wlearn
  To Discriminant
  wdis = selected ("Discriminant")

# test with ....

  call extract_dataset fulltable fullindex fulleqclass mtest
  mtest = fulltable_sel
  mtest_eq = fulleqclass_sel
  call do_one_bm_test mdis mtest Bmm Mmm MM mtest_eq
  resultmm = selected ("TableOfReal")
  
  call extract_dataset fulltable fullindex fulleqclass women
  women = fulltable_sel
  women_eq = fulleqclass_sel
  call do_one_bm_test mdis women Bmw Mmw MW women_eq
  resultmw = selected ("TableOfReal")
  
  call extract_dataset fulltable fullindex fulleqclass wtest
  wtest = fulltable_sel
  wtest_eq = fulleqclass_sel
  call do_one_bm_test wdis wtest Bww Mww WW wtest_eq
  resultww = selected ("TableOfReal")
  
  call extract_dataset fulltable fullindex fulleqclass men
  men = fulltable_sel
  men_eq = fulleqclass_sel
  call do_one_bm_test wdis men Bwm Mwm WM men_eq
  resultwm = selected ("TableOfReal")
  
  call get_procrustes_transformed_table men women
  womentomen = selected ("TableOfReal")
  call get_procrustes_transformed_table women men
  mentowomen = selected ("TableOfReal")

  call do_one_bm_test mdis womentomen Bmwp Mmwp MWp women_eq
  resultmwp = selected ("TableOfReal")

  call do_one_bm_test wdis mentowomen Bwmp Mwmp WMp men_eq
  resultwmp = selected ("TableOfReal")
  
# All results in one table
  
  select resultmm
  plus resultmw
  plus resultww
  plus resultwm
  plus resultmwp
  plus resultwmp
  Append columns
  Rename... results

  Write to short text file... 'tablefile$'
endproc

procedure preparedata
  name$ = "barks_total_frame123_mf_meansperspeaker"
  Read from file... 'datadir$''name$'.TableOfReal
  fulltable_tmp = selected ("TableOfReal")

  Extract column ranges... 19:36
  fulltable = selected ("TableOfReal")

  Extract row labels as Strings
  strings = selected ("Strings")
  numberOfStrings = Get number of strings
  Read from file... 'datadir$''name$'_index.TableOfReal
  fullindex = selected ("TableOfReal")
  Rename... index
  numberOfIndices = Get number of rows
  select strings
  for i to numberOfIndices
    select fullindex
	spr$ = Get row label... i
    indexs1 = TableOfReal_index[i,1]
    indexs2 = TableOfReal_index[i,2]
	select strings	
    for j from indexs1 to indexs2
      Set string... j 'spr$'	
    endfor  
  endfor
  select strings
  To EquivalenceClass
  fulleqclass = selected ("EquivalenceClass")
  select strings
  Remove
endproc

procedure extract_dataset t_id index_id eqclass choice$
  ml1 = 1
  ml2 = 326
  mt1 = 327
  mt2 = 438
  wl1 = 439
  wl2 = 574
  wt1 = 575
  wt2 = 630
  
  select index_id
  
  if choice$ = "men"
    # men set  
    index1 = Get value... ml1 1
    index2 = Get value... mt2 2
  elsif choice$ = "women"
    # women set  
    index1 = Get value... wl1 1
    index2 = Get value... wt2 2
  elsif choice$ = "mlearn"
    # men learn
    index1 = Get value... ml1 1
    index2 = Get value... ml2 2
  elsif choice$ = "mtest"  
    # men test
    index1 = Get value... mt1 1
    index2 = Get value... mt2 2
  elsif choice$ = "wlearn"
    # women learn
    index1 = Get value... wl1 1
    index2 = Get value... wl2 2
  elsif choice$ = "wtest"  
    # women test
    index1 = Get value... wt1 1
    index2 = Get value... wt2 2 
  endif
  printline 'index1':'index2'
  select t_id
  Extract row ranges... 'index1':'index2'
  fulltable_sel = selected ("TableOfReal")
  Rename... 'choice$'
  select eqclass
  Extract part... 'index1' 'index2'
  fulleqclass_sel = selected ("EquivalenceClass")
  Rename... 'choice$'
endproc

procedure do_one_bm_test dis_dot t_dot label2$ label3$ comment$ eqclass_id
  select dis_dot
  name1_dot$  = selected$ ("Discriminant")
  select t_dot
  name2_dot$ = selected$ ("TableOfReal")
  fileappend 'file$' Train: 'name1_dot$', test: 'name2_dot$' 'comment$'
  ntries_dot = 50
  call fcalpha dis_dot t_dot 0.5 ntries_dot eqclass_id
  tr_dot = selected ("TableOfReal")
  Set column label (index)... 1 alpha
  Set column label (index)... 2 'label2$'
  Set column label (index)... 3 'label3$'
endproc

procedure fcalpha dis_fca tab_fca prob_fca ntries_fca eqclass_id
  nalpha_fca = 21
  dalpha_fca = 0.05
  alphamin_fca = 0
  Create TableOfReal... tr nalpha_fca 3
  tresult_fca = selected ("TableOfReal")
  for ialpha to nalpha_fca
    alf_fca = alphamin_fca + (ialpha-1) * dalpha_fca
    call get_fc_blocked dis_fca tab_fca alf_fca prob_fca ntries_fca eqclass_id
    fcb_fca = fc_gfcb
    call   get_fc_mixed dis_fca tab_fca alf_fca prob_fca ntries_fca
    fcm_fca = fc_gfcm
    fcb$ = fixed$ (fcb_fca, 3)
    fcm$ = fixed$ (fcm_fca, 3)
    alf$ = fixed$ (alf_fca, 3)
    fileappend 'file$' 'tab$'alpha = 'alf$' fcb = 'fcb$' fcm = 'fcm$' ('ntries_fca' tries)'nl$'
    select tresult_fca
    Set value... ialpha 1 alf_fca
    Set value... ialpha 2 fcb_fca
    Set value... ialpha 3 fcm_fca
  endfor
  select tresult_fca
endproc


procedure get_fc_blocked dis_gfcb tab_gfcb alpha_gfcb prob_gfcb ntries_gfcb eqclass_id
  fc_gfcb = 0
  for k1 to ntries_gfcb
    call randomize_bf_table_blocked tab_gfcb eqclass_id
    tabr_gfcb = selected ("TableOfReal")
    call get_fc dis_gfcb tabr_gfcb alpha_gfcb prob_gfcb
    fc_gfcb += fc
    select tabr_gfcb
    Remove
  endfor
  fc_gfcb = fc_gfcb / ntries_gfcb
endproc

procedure get_fc_mixed dis_gfcm tab_gfcm alpha_gfcm prob_gfcm ntries_gfcm
  fc_gfcm = 0
  for k2 to ntries_gfcm
    call randomize_bf_table_mixed tab_gfcm
    tabr_gfcm = selected ("TableOfReal")
    call get_fc dis_gfcm tabr_gfcm alpha_gfcm prob_gfcm
    fc_gfcm += fc
    select tabr_gfcm
    Remove
  endfor
  fc_gfcm = fc_gfcm / ntries_gfcm
endproc

procedure get_fc dis_gfc tab_gfc alpha_gfc prob_gfc
  select dis_gfc
  plus tab_gfc
  To ClassificationTable (dw)... y y alpha_gfc prob_gfc
  ct_gfc = selected ("ClassificationTable")
  ttmp_gfc = selected ("TableOfReal")
  select ct_gfc
  To Confusion
  fc = Get fraction correct
  plus ttmp_gfc
  plus ct_gfc
  Remove
endproc

procedure randomize_bf_table_blocked tab_rftb eqclass_id
  select eqclass_id
  To Permutation... y
  pid_rftb = selected ("Permutation")
  plus tab_rftb
  Permute rows
  tabrandom_rftb = selected ("TableOfReal")
  select pid_rftb
  Remove
  select tabrandom_rftb	
endproc

procedure randomize_bf_table_mixed tab_rftm
  select tab_rftm
  Randomize rows
  tabrandom_rftm = selected ("TableOfReal")
endproc

procedure get_procrustes_transformed_table ref_id test_id
  select ref_id
  To TableOfReal (means by row labels)... no
  tm_1 = selected ("TableOfReal")
  To Configuration
  cf_1 = selected ("Configuration")
  select test_id
  To TableOfReal (means by row labels)... no
  tm_2 = selected ("TableOfReal")
  To Configuration
  cf_2 = selected ("Configuration")
  plus cf_1
  To Procrustes... n
  procr = selected ("Procrustes")
  select test_id
  To Configuration
  test_id_cf = selected ("Configuration")
  plus procr
  To Configuration
  test_id_cf_procr = selected ("Configuration")
  To TableOfReal
  test_id_procr = selected ("TableOfReal")
  select tm_1
  plus tm_2
  plus cf_1
  plus cf_2
  plus procr
  plus test_id_cf
  plus test_id_cf_procr
  Remove
  select test_id_procr
endproc

procedure draw_adaptation_results

  Read from file... 'tablefile$'
  tab_dar = selected ("TableOfReal")
  a = 1/2.54
  x0 = 1.65
  y0 = 0.60
  width = 4
  height = 2.45
  
  Erase all
  Font size... 10
  vpx1 = x0 * a
  vpx2 = vpx1 + width * a
  vpy1 = y0 * a
  vpy2 = vpy1 + height * a
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
 # call draw_one_adaptation_result 2 0.50 0.8 (a) Ml-Mt
  call draw_one_adaptation_result 2 0.0 0.8 (a) Ml-Mt
   
  vpx1 = vpx2 + x0*a
  vpx2 = vpx1 + width * a
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
#  call draw_one_adaptation_result 5 0.0 0.5 (b) Ml-W
  call draw_one_adaptation_result 5 0.0 0.8 (b) Ml-W
  
  vpx1 = x0 * a
  vpx2 = vpx1 + width * a
  vpy1 = vpy2 + y0
  vpy2 = vpy1 + height * a
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
#  call draw_one_adaptation_result 11 0.0 0.5 (c) Wl-M
   call draw_one_adaptation_result 11 0.0 0.8 (c) Wl-M
 
  vpx1 = vpx2 + x0*a
  vpx2 = vpx1 + width * a
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
#  call draw_one_adaptation_result 8 0.50 0.8 (d) Wl-Wt
  call draw_one_adaptation_result 8 0.0 0.8 (d) Wl-Wt

  vpx1 = x0 * a
  vpx2 = vpx1 + width * a
  vpy1 = vpy2 + y0
  vpy2 = vpy1 + height * a
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
 # call draw_one_adaptation_result 17 0.50 0.8 (e) Wl-M__p_
  call draw_one_adaptation_result 17 0.0 0.8 (e) Wl-M__p_

  vpx1 = vpx2 + x0*a
  vpx2 = vpx1 + width * a
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
#  call draw_one_adaptation_result 14 0.50 0.8 (f) Ml-W__p_
  call draw_one_adaptation_result 14 0.0 0.8 (f) Ml-W__p_
 
  vpx1 = x0 * a
  vpx2 = (x0 + width + x0 + width) * a
  vpy1 = y0 * a
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
# Outer viewport:
# x: (5.032152230971128 - 0.06627296587926503)*2.54 =  12.61cm
# y: (4.718810148731409 + 0.152668416447)*2.54 = 12.37cm

  printline width x height = 12.7 x 12.4 cm
  call save adaptive-bf
endproc

procedure draw_one_adaptation_result col_doar ymin ymax texttop$
  Set column label (index)... col_doar-1 Step size \al
  Set column label (index)... col_doar Fraction correct
  Draw scatter plot... col_doar-1 col_doar 0 0 0 0 ymin ymax 6 n + y
  Draw scatter plot... col_doar-1 col_doar+1 0 0 0 0 ymin ymax 6 n 0 n
  Text top... n 'texttop$'
  baseline = Get value... 1 col_doar
  baseline$ = fixed$ (baseline, 3)
  One mark left... 'baseline$' y y y
  Marks bottom every... 1 0.1 n y n
  Marks left every... 1 0.1 n y n
  One mark bottom... 0.5 y n n
endproc
   
procedure save gfile$
  path$ = "'savedir$'"+"'gfile$'"
  Write to EPS file... 'path$'.eps
  system epstopdf --outfile='path$'.pdf 'path$'.eps
endproc 

  
  
  
