# adaption-visualised-weenink-10m.praat
# djmw 20050310, 20050530

draw_color = 1
savedir$ = "/home/david/tex/thesis/anorm/"

Create TableOfReal (Weenink 1985)... Men
To TableOfReal (means by row labels)... no
tm = selected ("TableOfReal")
Copy... tm2
tm2 = selected ("TableOfReal")
plus tm
Append columns
tv = selected ("TableOfReal")
select tm2
Remove

x = 730
y = 1300
xr = 798
yr = 1340
delta = 1
Font size... 10

# 1 means + new ?
# 2 distances
# 3 minimum distance a
# 4 move means (arrows)
# 5 new positions
# 6 ready

a = 2.54

procedure setinnervp index
  #drawing order: left to right
  
  height= 14/a
  nx = 2
  ny = 3
  width = nx * height / ny
  xwp = width / nx
  ywp = height / ny
  xlo = 1/7 * xwp
  xro = xlo
  ybo = 1/6 * ywp
  yto = ybo

  if index > 0
    irow = (index - 1) div nx + 1
    icol = index - (irow - 1) * nx
    vpx1 = (icol-1) * xwp + xlo
    vpx2 = icol * xwp - xro
    vpy1 = (irow - 1) * ywp + yto
    vpy2 = irow * ywp - ybo
  else
    vpx1 = xlo
    vpx2 = width - xro
    vpy1 = yto
    vpy2 = height - ybo
  endif
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
endproc

procedure save file$
  call setinnervp 0
  path$ = "'savedir$'"+"'file$'"
  Write to EPS file... 'path$'.eps
  system epstopdf --outfile='path$'.pdf 'path$'.eps
endproc 

procedure draw_reference index texttop$
  call setinnervp index
  select tm
  Draw scatter plot... 1 2 0 0 200 900 500 2500 10 y + no
  # decorations
  Draw inner box
  Marks bottom every... 1 100 n y n
  Marks left every... 1 500 n y n
  Text bottom... n %F__1_
  Text special... 100 Centre 1500 Half Times 10 90 %F__2_
  Text top... no 'texttop$'
endproc

Erase all

# plaatje 1
call draw_reference 1 (a)
if draw_color = 1
  Red
endif
Text... x Centre y Half ?
Black

# plaatje 2
# afstanden

call draw_reference 2 (b)
select tv
Copy... tv2
tv2 = selected ("TableOfReal")
for i to 12
  Set value... i 1 x
  Set value... i 2 y
endfor
if draw_color = 1
  Red
endif
Text... x Centre y Half ?
Draw vectors... 1 2 4 5 200 900 500 2500 Arrow 0 n
Black


# plaatje 3
# een a ipv ?
call draw_reference 3 (c)
select tv2
if draw_color = 1
  Red
endif
Dotted line
Draw vectors... 1 2 4 5 200 900 500 2500 Arrow 0 n
Plain line
if draw_color = 1
  Blue
endif
Line width... 3
Draw arrow... x y xr yr
Line width... 1
Text... x Centre y Half ?
Black


# plaatje 4
# vector
call draw_reference 4 (d)
if draw_color = 1
  Blue
endif
Text... x Centre y Half a
Draw arrow... x y xr yr
Black

#plaatje 5
# allemaal vectors
ddx = xr - x
ddy = yr - y

call draw_reference 5 (e)
select tv
Copy... tv3
tv3 = selected ("TableOfReal")
Formula... if col=4 then self-delta*ddx else if col=5 then self - delta*ddy else self fi fi
if draw_color = 1
  Blue
endif
Line width... 2
Draw vectors... 1 2 4 5 200 900 500 2500 Arrow 0 n
Line width... 1
Text... x Centre y Half a
Black

#plaatje 6
# nieuwe toestand
select tm
Formula... if col=1 or col=2 then TableOfReal_tv3[row,col+3] else self endif
call draw_reference 6 (f)
Grey
select tv3
Draw scatter plot... 1 2 0 0 200 900 500 2500 8 y + no
Black

call save adaption-visualised-weenink-10m

