# timit_test_vigilance_learningrate.praat
# 20040401 djmw

name$ = "timit_test_vigilance_learningrate"

savedir$ = "/home/david/tex/thesis/cart/"

include /home/david/tex/praat_procedures.praat

call logfile_open 'name$'

artnet$ = "cart"
learn$ = "learn"
learnc$ = "learn"
test$ = "learn"
testc$ = "learn"

Create FuzzyCategoryART... 'artnet$' 9 1300
# 9 pc from the first 10 speakers in dr1 1228 items
# cpm0 dac0 dpk0 edr0 grl0 jeb1 jwt0 kls0 klw0 mgg0

Read from file... 'savedir$'barks_d1R0SmP00A1_01_pc9_sp10.TableOfReal

Rename... 'learn$'

call vp_init 12 6 2 1 1
call vp_next
Draw box plots... 0 0 0 0 -170 170 y
# Centering is essential !!
Centre columns
Formula... (self+70)/140
call vp_next
Draw box plots... 0 0 0 0 0 1 y
call save cart-timit-normalize-boxplots

Split into Pattern and Categories... 1 1228 0 0

procedure test
  nepoch = 2
  nrho = 2
  nbeta = 2
  nrep = 2
  epochb = 1
  epoche = 6
endproc

nrep = 10
nepoch = 10
nrho = 7
nbeta = 5
epochb = 20
epoche = 200

call test

depoch = (epoche - epochb)/ (nepoch - 1)


rhob = 0.35
rhoe = 0.95
drho = (rhoe -rhob) / (nrho - 1)

betab = 0.05
betae = 1
dbeta = (betae - betab) / (nbeta - 1)

nrows = nrep * nepoch * nrho * nbeta * 2
ncols = 7
Create TableOfReal... results nrows ncols
Set column label (index)... 1 rep
Set column label (index)... 2 epoch
Set column label (index)... 3 rho
Set column label (index)... 4 beta
Set column label (index)... 5 frc
Set column label (index)... 6 commit
Set column label (index)... 7 track

row = 0
for track from 0 to 1
  for rep to nrep
  # eigenlijk: rho = 0
    rho = rhob
    for j to nrho
      beta = betab
      for k to nbeta
        select FuzzyCategoryART 'artnet$'
        Reset... 0.001
        epoch = epochb
        for l to nepoch
          select FuzzyCategoryART 'artnet$'
          plus Pattern 'learn$'
          plus Categories 'learnc$'
          Learn... rho beta 'track' epoch Permutation 0
          select FuzzyCategoryART 'artnet$'
          ncommit = Get number of committed nodes
          plus Pattern 'learn$'
          To Categories
          select Categories 'testc$'
          plus Categories untitled
          To Confusion
          frc = Get fraction correct
          select Categories untitled
          plus Confusion untitled
          Remove
          logtext$ = "Rep,epoch,rho,beta,frc,ncommit,track: 'rep' 'epoch' 'rho' 'beta' 'frc' 'ncommit' 'track'"
          call logfile_append 'logtext$'
          select TableOfReal results
          row += 1
          Set value... row 1 rep
          Set value... row 2 epoch
          Set value... row 3 rho
          Set value... row 4 beta
          Set value... row 5 frc
          Set value... row 6 ncommit
          Set value... row 7 track
          epoch += depoch
        endfor ; l
        select FuzzyCategoryART 'artnet$'
        plus Pattern 'learn$'
        Prune category nodes
        select FuzzyCategoryART 'artnet$'
        ncommitp = Get number of committed nodes
        logtext$ = "-- Before/after pruning -- 'ncommit' 'ncommitp'"
        fileappend 'log$' 'logtext$''newline$'
        beta += dbeta	  
      endfor ; k
      rho += drho
    endfor ; j
  endfor ; rep
endfor ; track
  
call logfile_close

select TableOfReal results
Write to short text file... 'savedir$''name$'-'logfile_date$'.TableOfReal
