# get_speaker_centroids.praat
# 20050512 djmw, 20050529

# calculate the speakers centroid, from the maximally 20 vowel averages, to have a centroid
# that is unbiased by the frequency of occurrence of a vowel.

datadir$ = "/home/david/tex/thesis/data/"

procedure getfrom3 name$
  # measurements at frame 1,2,3
  for i to 3
     Read from file... 'datadir$'barks_total_frame'i'_mf_meansperspeaker.TableOfReal
     t'i' = selected ("TableOfReal")
  endfor

  Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker_index.TableOfReal
  Rename... index
  index = selected ("TableOfReal")

  # frame1,2,3 into 1 table (parallel)

  select t1
  plus t2
  plus t3
  Append columns
  t123 = selected ("TableOfReal")
endproc

procedure getfrom1 name$
  Read from file... 'datadir$''name$'.TableOfReal
  Rename... t123
  t123 = selected ("TableOfReal")
  Read from file... 'datadir$''name$'_index.TableOfReal
  Rename... index
  index = selected ("TableOfReal")
endproc

# call getfrom3 barks_total_frame123_mf

call getfrom1 barks_total_frame123_mf_stressed

select t123
ncols = Get number of columns

select index
nspeakers = Get number of rows

# for testing:
# nspeakers=10

nrows = nspeakers

Create TableOfReal... result nrows ncols
result = selected ("TableOfReal")

for j to ncols
  select t123
  label$ = Get column label... j
  select result
  Set column label (index)... j 'label$'
endfor

for i to nspeakers
  select index
  ib = Get value... i 1
  ie = Get value... i 2
  rowlabel$ = Get row label... i
  select t123
  Extract row ranges... 'ib':'ie'
  tmp = selected ("TableOfReal")
  Change row labels... .* a 0 Regular Expressions
  To TableOfReal (means by row labels)... n
  Rename... tmpm
  select result
  for j to ncols
     value =  TableOfReal_tmpm[1,j] 
     Set value... i j value
  endfor
  Set row label (index)... i 'rowlabel$'
  select tmp
  plus TableOfReal tmpm
  Remove
endfor

# Make last row equal to overall average
select result
Extract row ranges... 1 : 438
Change row labels... .* a 0 Regular Expressions
To TableOfReal (means by row labels)... n
Set row label (index)... 1 MALE
Rename... MALE

select result
Extract row ranges... 439 : 630
Change row labels... .* a 0 Regular Expressions
To TableOfReal (means by row labels)... n
Set row label (index)... 1 FEMALE
Rename... FEMALE

select TableOfReal MALE
plus TableOfReal FEMALE
Append
Change row labels... .* a 0 Regular Expressions
To TableOfReal (means by row labels)... n
Set row label (index)... 1 MF
Rename... MF

select result
plus TableOfReal MALE
plus TableOfReal FEMALE
plus TableOfReal MF
Append

Write to short text file... 'datadir$''name$'_speakercentroids.TableOfReal