# get_vowel_means_per_spreaker.praat
# djmw 20050313, 20050511, 20050513

form Get speaker averages
  comment Default extension is .TableOfReal
  word Table barks_total_frame2_mf
  word Index barks_total_frame123_mf_index
  natural Begin 1
  natural End 630
  word Resultnamepart result
endform

ext$ = ".TableOfReal"
datadir$ = "/home/david/tex/thesis/data/"

procedure read name1$ name2$
  file1$ = datadir$ + name1$ + ext$
  file2$ = datadir$ + name2$+ ext$

  Read from file... 'file1$'
  table1 = selected ("TableOfReal")
  ncols_result = Get number of columns
  Read from file... 'file2$'
  speakers = selected ("TableOfReal")
endproc

nspeakers = end - begin + 1

resultname$ = resultnamepart$ + "_index_sp'begin'_'end'" + ext$

procedure speaker_averages table_in speaker_index spbegin spend
  Create TableOfReal... result1 1 ncols_result
  result = selected ("TableOfReal")
  Create TableOfReal... result_index nspeakers 2
  spmeans = selected ("TableOfReal")
  sprow = 0
  indexinmeans = 0
  for i from spbegin to spend
    select speaker_index
    rowbegin = Get value... i 1
    rowend = Get value... i 2
    select table_in
    Extract row ranges... 'rowbegin':'rowend'
    extract = selected ("TableOfReal")
    To TableOfReal (means by row labels)... 0
    centroid = selected ("TableOfReal")
    nrows = Get number of rows
    plus result
    Append
    appended = selected ("TableOfReal")
    select result
    plus centroid
    plus extract
    Remove
    result = appended
	
    select spmeans
    sprow += 1
    indexinmeans += 1
    Set value... sprow 1 indexinmeans
    indexinmeans += nrows - 1
    Set value... sprow 2 indexinmeans	
  endfor
  select result
  Remove row (index)... 1
  Rename... result_'spbegin'_'spend'
endproc

call read 'table$' 'index$'
call speaker_averages table1 speakers begin end

# preprocessing only 1 time.
procedure extract_frames
  Read from file... 'datadir$'barks_d0R0SmfP00A1_03.TableOfReal
  tab = selected ("TableOfReal")
  Extract column ranges... 9:26
  name$ = "barks_total_frame1_mf"
  Write to short text file... 'datadir$''name$'.TableOfReal
  Remove
  select tab
  Extract column ranges... 45:62
  name$ = "barks_total_frame3_mf"
  Write to short text file... 'datadir$''name$'.TableOfReal
endproc

procedure get_all_means_frame_plus_index
  select result
  Write to short text file... 'datadir$''table$'_meansperspeaker.TableOfReal
  select spmeans
  Write to short text file... 'datadir$''table$'_meansperspeaker_index.TableOfReal
endproc

call get_all_means_frame_plus_index