# f1_vs_f2_mf_medians.praat
# djmw 20060329

form Draw f1 vs f2 medians
  boolean Log_scale 0
endform

datadir$ = "/home/david/tex/thesis/data/"

include save.praat

procedure read
  Read from file... 'datadir$'analyse_f_m.TableOfReal
  .m = selected ("TableOfReal")
  Extract column ranges... 4 5
  .ms = selected ("TableOfReal")
  To TableOfReal (medians by row labels)... n
  mm = selected ("TableOfReal")
  Read from file... 'datadir$'analyse_f_f.TableOfReal
  .f = selected ("TableOfReal")
  Extract column ranges... 4 5
  .fs = selected ("TableOfReal")
  To TableOfReal (medians by row labels)... n
  fm = selected ("TableOfReal")
  select .m
  plus .f
  plus .ms
  plus .fs
  Remove
endproc

call read
call draw

procedure draw
  select mm
  plus fm
  Append columns
  mf = selected ("TableOfReal")
  .xmin = 350
  .xmax = 900
  .ymin = 900
  .ymax = 2500
  .margex = 100
  .margey = 200
  .ext$ = "_lin"
  xlabel$ = "%F__1_"
  ylabel$ = "%F__2_"
  if log_scale = 1
    select mf
    Formula... log10(self)
    .xmin = 2.5
    .xmax = 3
    .ymin = 2.9
    .ymax = 3.4
    .margex = 0.1
    .margey = 0.1
    .ext$ = "_log"
    xlabel$ = "log"+xlabel$
    ylabel$ = "log"+ylabel$
  endif
  a = 2.54
  Erase all
  Select outer viewport... 0 10/a 0 10/a
  Draw vectors... 1 2 3 4 .xmin .xmax .ymin .ymax Line 10 n
  Draw inner box
  Marks left every... 1 .margey y y n
  Marks bottom every... 1 .margex y y n
  Text bottom... y 'xlabel$'
  Text left... y 'ylabel$'
  call save f1_vs_f2_mf_medians'.ext$'
endproc