# pols_vannierop_discriminanten.praat
# 20060419 djmw

call m50w25

procedure m50w25
  Create TableOfReal (Pols 1973)... no
  Formula... if col<4 then log10(self) else self fi
  m50 = selected ("TableOfReal")
  Copy... m50c1
  m50c1 = selected ("TableOfReal")
  Copy... m50c2
  m50c2 = selected ("TableOfReal")

  Create TableOfReal (Van Nierop 1973)... no
  Formula... if col<4 then log10(self) else self fi
  w25 = selected ("TableOfReal")
  Copy... w25c1
  w25c1 = selected ("TableOfReal")
  Copy... w25c2
  w25c2 = selected ("TableOfReal")


  printline m50:
  call get_fcs m50c1

  printline w25:
  call get_fcs w25c1

  printline m50: (centred)
  call tor_modify_centre m50c2
  call get_fcs m50c2

  printline w25: (centred)
  call tor_modify_centre w25c2
  call get_fcs w25c2

endproc


procedure get_fcs .tor
  call get_fc .tor
  fc1 = fc

  select conf
  Condense... \ct o 0 Literals
  conf1 = selected ("Confusion")
  Condense... \yc \o/ 0 Literals
  conf2 = selected ("Confusion")
  Condense... \ic e 0 Literals
  conf3 = selected ("Confusion")
  fc2 = Get fraction correct

  select .tor
  Change row labels... \ct o 0 Literals
  Change row labels... \yc \o/ 0 Literals
  Change row labels... \ic e 0 Literals

  call get_fc .tor
  fc3 = fc
  printline 'fc1' 'fc2' 'fc3' (log(f), conf-condensed, table-condensed)
  select conf1
  plus conf2
  plus conf3
  Remove
endproc

procedure get_fc .tor
  select .tor
  To Discriminant
  .dis = selected ("Discriminant")
  plus .tor
  To ClassificationTable... yes yes
  .ct = selected ("ClassificationTable")
  To Confusion
  conf = selected ("Confusion")
  fc = Get fraction correct
  select .ct
  plus .dis
  Remove
endproc

! based on 12 vowels / speaker
procedure tor_modify_centre .tor
  select .tor
  .ncols = Get number of columns
  .nrows = Get number of rows
  Copy... torcs
  for .i to .nrows
    .spid = floor ((.i-1)/12) + 1
    .spid$ = "'.spid'"
    Set row label (index)... .i '.spid$'
  endfor
  
  To TableOfReal (means by row labels)... yes
  Rename... torc
  Create TableOfReal... means 1 .ncols
  for .i to .ncols
    select .tor
    .mean = Get column mean (index)... .i
    select TableOfReal means
    Set value... 1 .i .mean
  endfor

  select .tor
  Formula... self[col] - (TableOfReal_torc[col] - TableOfReal_means[1,col])

  select TableOfReal torc
  plus TableOfReal torcs
  plus TableOfReal means
  Remove
endproc
  