# discriminant_mf_perfractionscorrect.praat
# djmw 20050315

Read from file... /home/david/tex/thesis/data/barks_total_frame2_mf_meansperspeaker_index.TableOfReal
index = selected ("TableOfReal")

Read from file... /home/david/tex/thesis/data/barks_total_frame2_mf_meansperspeaker.TableOfReal
Rename... t
t1 = selected ("TableOfReal")
Extract row ranges... 1:8078
Rename... m
t2 = selected ("TableOfReal")

select t1
Extract row ranges... 8079:11579
Rename... f
t3 = selected ("TableOfReal")

procedure classify
for i to 3
  select t'i'
  To Discriminant
  d'i' = selected ("Discriminant")
  print 1: 
  for j to 3
    select d'i'
    plus t'j'
    To ClassificationTable... y y
    ct = selected ("ClassificationTable")
    To Confusion
    fcij = Get fraction correct
    plus ct
    Remove
    fc3$ = fixed$(fcij, 3)
    print  'fc3$'
  endfor
  print 'newline$'
endfor
endproc

printline All data
call classify

printline Only filters >= 3

for i to 3
  select t'i'
  Extract column ranges... 3:18
  t'i' = selected ("TableOfReal")
endfor

call classify

procedure cog_correction table_id table_index_id
  
  select table_index_id
  table_index$ = selected$ ("TableOfReal")

  select table_id
  Copy... tc
  tc = selected ("TableOfReal")
  nrows = Get number of rows

  # Get means per speaker in expanded table
  ii = 1
  for i to nrows
    if i > TableOfReal_'table_index$'[ii,2]
      ii += 1
    endif
    label$ = "'ii'"
    Set row label (index)... i 'label$'
  endfor

  To TableOfReal (means by row labels)... y
  Rename... perspeaker

  # Get means per speaker group in expanded table

  select table_id
  Copy... tmf
  for i to nrows
    if i <= TableOfReal_'table_index$'[438,2]
      label$ = "m"
    else
      label$ = "f"
    endif
    Set row label (index)... i 'label$'
  endfor

  To TableOfReal (means by row labels)... y
  Rename... diff

  # Get the dif
  Formula... self - TableOfReal_perspeaker[]

  # Correct by the diff

  select table_id
  Copy... diffcorrected
  Formula... self + TableOfReal_diff[]
  tdiff = selected ("TableOfReal")
  select TableOfReal tc
  plus TableOfReal perspeaker
  plus TableOfReal tmf
  plus TableOfReal diff
  Remove
endproc

printline cog correction

call cog_correction t1 index

t1 = tdiff
select t1
Extract row ranges... 1:8078
Rename... m
t2 = selected ("TableOfReal")

select t1
Extract row ranges... 8079:11579
Rename... f
t3 = selected ("TableOfReal")
call classify

