# make-m-f-categories.praat
# 20040617 djmw 

savedir$ = "/home/david/tex/thesis/nn-bias2/"
include /home/david/tex/praat_procedures.praat

Read from file... 'savedir$'barks_total_frame2_mf.TableOfReal
tableo = selected ("TableOfReal")
Read from file... 'savedir$'barks_total_frame2_mf.Strings
strings = selected ("Strings")

for i from 1 to 54357
  Set string... i m
endfor
for i from 54358 to 78374
Set string... i f
endfor

To Categories
cat = selected ("Categories")
plus tableo
Set row labels

select tableo
Rename... m_f_labeled

select strings
plus cat
Remove

# Get speaker sex recognition scores

procedure get_fraction_correct table pool apriori
  select table
  To Discriminant
  dis = selected ("Discriminant")
  plus table
  To ClassificationTable... 'pool' 'apriori'
  clas = selected ("ClassificationTable")
  To Confusion
  conf = selected ("Confusion")
  fc = Get fraction correct
  printline 
  select dis
  plus clas
  plus conf
  Remove
endproc

procedure get_mf_per_filter poolp apriorip rowp
  for i to 18
    select tableo
    Extract column ranges... 'i'
    tablem1 = selected ("TableOfReal")
    call get_fraction_correct 'tablem1' 'poolp' 'apriorip'
    select tabler
    Set value... rowp i+2 'fc'
    printline pool = 'poolp' 'apriorip = 'apriori' i = 'i', fc = 'fc'
    select tablem1
    Remove
  endfor
endproc

Create TableOfReal... m1 4 18+2
tabler = selected ("TableOfReal")
Set column label (index)... 1 pool
Set column label (index)... 2 apriori
for i to 18
  Set column label (index)... i+2 'i'
endfor

row = 0
for pool from 0 to 1
  for apriori from 0 to 1
    row += 1
    select tabler
    Set value... row 1 pool
    Set value... row 2 apriori
    call get_mf_per_filter 'pool' 'apriori' 'row'
  endfor
endfor

call vp_init 12 12 1 2 1

call vp_next
select tableo
To Discriminant
dist = selected ("Discriminant")
Draw eigenvector... 1 n 0 0 -1 1 1 + y y

call vp_next

select  tabler
Draw rows as histogram... "1 3" 3 20 0.4 0.7 0.5 1 0 "0.5 1" y
One mark left... 0.5 y y y

Write to short text file... 'savedir$'m-f-classification-results.TableOfReal
call save m-f-classification-results
