# f0-get-the-numbers.praat

#Read from file... /home/david/tex/thesis/data/barks_d0R0SmfP00A1_03.TableOfReal
table = selected ("TableOfReal")
Extract row ranges... 1:54357
m = selected ("TableOfReal")
select table
Extract row ranges... 54358:78374
f =  selected ("TableOfReal")
select m
plus f

procedure get_f0_stats condition$
  select m
  plus f
  Extract rows where... 'condition$'
  ms = selected ("TableOfReal", 1)
  fs = selected ("TableOfReal", 2)
  select ms
  m_rows = Get number of rows
  select fs
  f_rows = Get number of rows
  sum = m_rows + f_rows
  printline 'condition$' : 'm_rows' + 'f_rows' = 'sum'
  select ms
  plus fs
  Remove
endproc

procedure simple_stats
  call get_f0_stats self[6]=0
  call get_f0_stats self[7]=0
  call get_f0_stats self[8]=0
  call get_f0_stats self[6]=0 or self[7]=0 or self[8]=0
  call get_f0_stats self[6]=0 and self[7]=0 and self[8]=0
  call get_f0_stats self[7]=0 and (self[6]=0 or self[8]=0)
endproc

call simple_stats

#
# calculate the numbers in a "cone" in the origin.
# get lines where the octave line form the bisectrice
# Use
# 
# y = tg(alfa+beta), x = tg(alfa-beta), a = tg(alfa), b=tg(beta)
# y = (a + b) / (1 - a * b); 
# x = (a - b) / (1 + a * b);
#
# x  => b = (a - x) / (1 + ax) in y
# y = (a+b)/(1-ab) = (a 
#
#
#
x1 = 0.4
a1 = 0.5
 b = (a1 - x1) / (1 + a1 * x1)
y1 = (a1 +  b) / (1 - a1 * b)

a2 = 2
x2 = (a2 - b)/ (1 + a2 * b)
y2 = (a2 + b)/ (1 - a2 * b)

x1$ = fixed$(x1,2)
y1$ = fixed$(y1,2)
x2$ = fixed$(x2,2)
y2$ = fixed$(y2,2)
printline (tg(a-b), tg(a+b)) : ('x1$', 'y1$')   ('x2$', 'y2$')

call get_f0_stats self[6]<>0 and self[8]<>0 and self[8]/self[6]<'x1$'
call get_f0_stats self[6]<>0 and self[8]<>0 and self[8]/self[6]>'y2$'
call get_f0_stats self[6]>0 and (self[8]/self[6]>'x1$' and self[8]/self[6]<'y1$')
call get_f0_stats self[6]<>0 and (self[8]/self[6]>'x2$' and self[8]/self[6]<'y2$')
call get_f0_stats self[6]<>0 and (self[8]/self[6]>='y1$' and self[8]/self[6]<='x2$')


call get_f0_stats self[6]>0 and self[7]>0 and (self[8]/self[6]>'x1$' and self[8]/self[6]<'y1$')
call get_f0_stats self[6]<>0 and self[7]>0 and (self[8]/self[6]>'x2$' and self[8]/self[6]<'y2$')
call get_f0_stats self[6]<>0 and self[7]>0 and (self[8]/self[6]>='y1$' and self[8]/self[6]<='x2$')

