# pc1-vs-pc2-males-train-PCA.praat
# djmw 20050225
# djmw 20060413 VAF

# let op inverteren van PCA eigenvector 1 !!!!!!!!
Font size... 10
Black
Plain line

datadir$ = "/home/david/tex/thesis/data/"
savedir$ = "/home/david/tex/thesis/timit/"
name$ = "barks_total_frame2_mf"


procedure read_from_files frame
  name$ = "barks_total_frame'frame'_mf"
  Read from file... 'datadir$''name$'.TableOfReal
  table = selected ("TableOfReal")
  Read from file... 'datadir$'barks_total_frame123_mf_index.TableOfReal
  index = selected ("TableOfReal")
endproc

procedure calculate_male_averages frame
  call read_from_files frame
  call speaker_averages table index sp1 sp2
  Write to short text file... 'savedir$'barks_total_frame'frame'_meansbyrowlabels_sp'sp1'_'sp2'.TableOfReal
endproc

sp1 = 1
sp2 = 326
procedure calc_male_averages_perframe
  for frame to 3
    call calculate_male_averages 'frame'
  endfor
endproc

#call calc_male_averages_perframe

procedure set_viewport x1 x2 y1 y2
  yx_ratio = (y2-y1)/(x2-x1)
  vpx1 = 2/2.54
  vpx2 = 10/2.54
  vpy1 = 1/2.54
  vpy2 = vpy1 + (vpx2 - vpx1) * yx_ratio
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
endproc

procedure save_graphics file$
  filepath$ = "'savedir$'"+"'file$'"
  Write to EPS file... 'filepath$'.eps
  system epstopdf --outfile='filepath$'.pdf 'filepath$'.eps
endproc

procedure garnish x1 x2 y1 y2
  Draw inner box
  Text left... y pc2
  Text bottom... y pc1
  One mark bottom... x1 y y n
  One mark bottom... x2 y y n
  One mark left... y1 y y n
  One mark left... y2 y y n
  Marks bottom every... 1 10 n y n
  Marks left every... 1 10 n y n
endproc

procedure draw_pc1_vs_pc2
  Read from file... 'savedir$'barks_total_frame2_meansbyrowlabels_sp'sp1'_'sp2'.TableOfReal
  table = selected ("TableOfReal")
  To PCA
  pca = selected ("PCA")
  vaf1 = Get fraction variance accounted for... 1 1
  vaf2 = Get fraction variance accounted for... 2 2
  vaf12 = Get fraction variance accounted for... 1 2
  printline barks_total_frame2_meansbyrowlabels_sp'sp1'_'sp2'
  printline Variance accounted for pc1, 2, 1+2: 'vaf1' 'vaf2' 'vaf12'
  Invert eigenvector... 1
  plus table
  To Configuration... 0
  conf = selected ("Configuration")
  Erase all

  call set_viewport 60 130 80 120

  Black
  Draw sigma ellipses... 0.5 1 2 x1 x2 y1 y2 12 no
  call garnish  60 130 80 120
#  call save_graphics pc1-vs-pc2-males-train-PCA
endproc
# We kunnen geen query van het viewport doen (praat 4.3.02)

for i to 3
  Read from file... 'savedir$'barks_total_frame'i'_meansbyrowlabels_sp'sp1'_'sp2'.TableOfReal
  frame'i' = selected ("TableOfReal")
  To TableOfReal (means by row labels)... 0
  tab'i' = selected ("TableOfReal")
endfor

select frame2
To PCA
pca2 = selected ("PCA")

# pca for all three frames
select frame1
plus frame2
plus frame3
Append
To PCA
pca123 = selected ("PCA")

procedure pca_reduced_table pca_id table_id
# invert de eigenvector zodat ellipsen NO lopen ipv NW
  select pca_id
  Invert eigenvector... 1 
  plus table_id
  To Configuration... 2
  ct = selected ("Configuration")
  To TableOfReal
  table = selected ("TableOfReal")
  select ct
  Remove
  select pca_id
  Invert eigenvector... 1
# en weer terug
endproc

procedure append_columns pca_id t1_id t2_id
  call pca_reduced_table pca_id t1_id
  t1 = table 
  call pca_reduced_table pca_id t2_id
  t2 = table
  select t1
  plus t2
  Append columns
endproc

procedure make_vectors pca_id table1 table2 table3
  call append_columns pca_id 'table1' 'table2'
  v12 = selected ("TableOfReal")
  call append_columns pca_id 'table2' 'table3'
  v23 = selected ("TableOfReal")
endproc

procedure draw_old
  Erase all
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
  Draw vectors... 1 2 5 6 x1 x2 y1 y2 Arrow 12 yes
  Text bottom... yes pc1
  Text left... yes pc2
  file$ = "dynamics_males_PCA"
  filepath$ = "'savedir$'"+"'file$'"
  printline 'filepath$'
  Write to EPS file... 'filepath$'.eps
  system epstopdf --outfile='filepath$'.pdf 'filepath$'.eps
endproc

procedure draw3 pca_id file$
  call make_vectors pca_id tab1 tab2 tab3
  call set_viewport 60 130 80 120
  select v12
  Draw vectors... 1 2 3 4 x1 x2 y1 y2 Line 12 yes
  select v23
  Draw vectors... 1 2 3 4 x1 x2 y1 y2 Line -12 no  
  call garnish  60 130  80 120
#  call save_graphics 'file$'
endproc

call draw_pc1_vs_pc2

#Erase all
#call draw3 pca123 dynamics_males_PCA
#Red
#call draw3 pca2
Black



	
